//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2008 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef EXECENGINE_H
#define EXECENGINE_H

#include "scalar.h"

class IVDShaderExecutionEngine {
public:
	virtual ~IVDShaderExecutionEngine() {}

	virtual void LoadSamplers(const VDShaderInterpreterSampler *const *samplers, int numSamplers) = 0;
	virtual bool LoadShader(const VDShaderFunction& func, const VDShaderBindingElement *pElements, int numElements, const VDShaderInterpConstant *pConstants, int numConstants, const VDShaderInterpreterInterpolator *interps, uint32 interpCount, IVDShaderLogOutput *out, bool showDisassembly) = 0;
	virtual void LoadConstants(const void *data) = 0;

	virtual void Execute(uint32 *dst, const VDShaderInterpreterInterpolator *interps, uint32 count) = 0;
};

#endif
