//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2007 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef INTERP_H
#define INTERP_H

#ifdef _MSC_VER
	#pragma once
#endif

#include <vd2/system/vdtypes.h>
#include "effect.h"
#include "scalar.h"
#include "execengine.h"

class VDShaderInterpreter : public IVDShaderExecutionEngine {
public:
	VDShaderInterpreter();
	~VDShaderInterpreter();

	void LoadSamplers(const VDShaderInterpreterSampler *const *samplers, int numSamplers);
	bool LoadShader(const VDShaderFunction& func, const VDShaderBindingElement *pElements, int numElements, const VDShaderInterpConstant *pConstants, int numConstants, const VDShaderInterpreterInterpolator *interps, uint32 interpCount, IVDShaderLogOutput *out, bool showDisassembly);
	void LoadConstants(const void *data);
	void Execute(uint32 *dst, const VDShaderInterpreterInterpolator *interps, uint32 count);

protected:
	vdfastvector<float> mRegisterFile;

	const VDShaderInterpreterSampler *const *mpSamplers;
	uint32		mSamplerCount;	
	int			mInputCount;
	int			mInputBase;
	int			mOutputBase;

	VDShaderScalarForm	mScalarForm;
};

#endif
