#ifndef f_PARAMDIALOG_H
#define f_PARAMDIALOG_H

#include <vd2/plugin/vdvideofilt.h>
#include "editor.h"

struct VDShaderVariable;
class VDShaderEffect;

struct VDFXUIBinding {
	const VDShaderVariable *mpVar;
	const char			*mpName;
	int					mSteps;
	VDFXParamType		mParamType;
	VDShaderConstant	mDefaultValue;
	VDShaderConstant	mMinValue;
	VDShaderConstant	mMaxValue;
};

class IVDShaderFilter {
public:
	virtual void GetParamBindings(vdfastvector<VDFXUIBinding>& bindings) = 0;
	virtual void SetEffectParameterLive(const char *name, const VDShaderConstant& v) = 0;
	virtual void ClearUIBindings() = 0;
	virtual void UpdateUIBindings(VDShaderEffect& effect) = 0;
};

class IVDShaderFilterConfigDialog {
public:
	virtual ~IVDShaderFilterConfigDialog() {}

	virtual VDXHWND GetHwnd() const = 0;
	virtual void UpdateParamsUI() = 0;
};

bool VDShaderFilterShowConfigDialog(VDXHWND hwndParent, VDShaderFilterConfig& cfg, IVDXFilterPreview *ifp, IVDShaderFilter *isf);
IVDShaderFilterConfigDialog *VDShaderFilterCreateConfigDialog(VDXHWND hwndParent, VDShaderFilterConfig& cfg, IVDXFilterPreview *ifp, IVDShaderFilter *isf);

#endif
