// Brightness/contrast
//
// Name: Brightness/Contrast
// Author: Avery Lee
// Description: Applies brightness and contrast adjustments.

texture vd_srctexture;

sampler src = sampler_state {
	Texture = (vd_srctexture);
	MinFilter = point;
	MagFilter = point;
	AddressU = clamp;
	AddressV = clamp;
};

float brightness <
	bool vd_tunable = true;
	float vd_tunablemin = -1;
	float vd_tunablemax = 1;
	float vd_tunablesteps = 40;
> = 0;

float contrast <
	bool vd_tunable = true;
	float vd_tunablemin = 0;
	float vd_tunablemax = 1;
	float vd_tunablesteps = 100;
> = 1;

float4 PS(float2 uv: TEXCOORD0) : COLOR0 {
	float3 px = tex2D(src, uv).rgb;
	
	return px*contrast + brightness;
}

technique {
	pass {
		PixelShader = compile ps_2_0 PS();
	}
}
