// Apply gamma correction
texture vd_srctexture;

sampler src = sampler_state {
	texture = (vd_srctexture);
};

float3 LinearToGamma(float3 c) {
	return c <= 0.0031308 ? 12.92*c : (1+0.055)*pow(c, 1.0/2.4) - 0.055;
}

float3 GammaToLinear(float3 c) {
	return c <= 0.04045 ? c * (1.0 / 12.92) : pow((c + 0.055) * (1.0 / 1.055), 2.4);
}

float4 PS(float2 uv: TEXCOORD0) : COLOR0 {
	float3 px = tex2D(src, uv).rgb;
	
	return LinearToGamma(px);
}

technique {
	pass {
		PixelShader = compile ps_2_0 PS();
	}
}
