// Threshold
//
// Name: Threshold
// Author: Avery Lee
// Description: Converts video into bi-level by thresholding luminance.

texture vd_srctexture;

sampler src = sampler_state {
	Texture = (vd_srctexture);
	AddressU = clamp;
	AddressV = clamp;
};

float threshold <
	bool vd_tunable = true;
	float vd_tunablemin = 0;
	float vd_tunablemax = 1;
	float vd_tunablesteps = 100;
> = 0.5;

float4 PS(float2 uv: TEXCOORD0) : COLOR0 {
	float3 px = tex2D(src, uv).rgb;
	
	return dot(px, float3(0.30, 0.59, 0.11)) >= threshold;
}

technique {
	pass {
		PixelShader = compile ps_2_0 PS();
	}
}
